﻿init python:

#Если не хотите разбираться в коде - берите так, все работает. 
#Вам нужны начальные настройки и переменные для выигрыша/проигрыша.
#Сама игра вызывается через функцию "call fac_memoria_game".
#Советую переименовать все переменные для уникализации.
#Я для всех сделал приставку "fac_". Можете просто через поиск заменить все эти приставки на свои.

    
    # НАСТРОЙКИ ИГРЫ ПО УМОЛЧАНИЮ:

    # набор типов карточек по умолчанию
    fac_all_cards = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I']
    # ширина и высота поля
    fac_ww = 3
    fac_hh = 3
    # сколько карточек можно открыть за 1 ход
    fac_max_c = 2
    # размер текста в карточке для текстового режима
    fac_card_size = 48
    # время, выделенное на прохождение
    fac_max_time = 30
    # пауза перед тем, как карточки исчезнут
    fac_wait = 0.5
    # режим карточек с изображениями, а не с текстом
    fac_img_mode = True

    fac_values_list = []
    fac_temp = []
    # если картинок найдено > 1,
    # то меняем набор типов карточек, на имена файлов
    if len(fac_temp) > 1:
        fac_all_cards = fac_temp
#    else:
        # иначе включаем текстовый режим,
        # так как картинок очень мало
#        fac_img_mode = False

    # функция инициализации игрового поля
    def fac_cards_init():
        global fac_values_list
        fac_values_list = []
        while len(fac_values_list) + fac_max_c <= fac_ww * fac_hh:
            fac_current_card = renpy.random.choice(fac_all_cards)
            for fac_i in range(0, fac_max_c):
                fac_values_list.append(fac_current_card)
        renpy.random.shuffle(fac_values_list)
        while len(fac_values_list) < fac_ww * fac_hh:
            fac_values_list.append('empty')

# экран игры
screen fac_memo_scr:
    # таймер    
    timer 1.0 action If (fac_memo_timer > 1, SetVariable("fac_memo_timer", fac_memo_timer - 1), Jump("fac_memo_game_lose") ) repeat True
    # поле
    grid fac_ww fac_hh:
        align (.5, .5) # в центре
        for fac_card in fac_cards_list:
            button:
                left_padding 0
                right_padding 0
                top_padding 0
                bottom_padding 0
                background None
                if fac_card["fac_c_value"] == 'none':
                    if fac_img_mode:
                        add "fac_card none"
                    else:
                        text " " size fac_card_size
                else:
                    if fac_card["fac_c_chosen"]:
                        if fac_img_mode:
                            add "fac_card " + fac_card["fac_c_value"]
                        else:
                            text fac_card["fac_c_value"] size fac_card_size
                    else:
                        if fac_img_mode:
                            add "fac_card back"
                        else:
                            text "#" size fac_card_size
                # нажатие на кнопку-карточку
                action If ( (fac_card["fac_c_chosen"] or not can_click), None, [SetDict(fac_cards_list[fac_card["fac_c_number"]], "fac_c_chosen", True), Return(fac_card["fac_c_number"]) ] )
    text str(fac_memo_timer) xalign .5 yalign 0.0 size fac_card_size

# сама игра
    
label fac_memoria_game:
    $ fac_cards_init()
    $ fac_cards_list = []
    python:
        for fac_i in range (0, len(fac_values_list) ):
            if fac_values_list[fac_i] == 'empty':
                fac_cards_list.append ( {"fac_c_number":fac_i, "fac_c_value": fac_values_list[fac_i], "fac_c_chosen":True} )   
            else:
                fac_cards_list.append ( {"fac_c_number":fac_i, "fac_c_value": fac_values_list[fac_i], "fac_c_chosen":False} )   
    $ fac_memo_timer = fac_max_time
    # показать экран с игрой
    show screen fac_memo_scr
    # основной цикл игры
    label fac_memo_game_loop:
        $ can_click = True
        $ fac_turned_cards_numbers = []
        $ fac_turned_cards_values = []
        $ fac_turns_left = fac_max_c
        label fac_turns_loop:
            if fac_turns_left > 0:
                $ fac_result = ui.interact()
                $ fac_memo_timer = fac_memo_timer
                $ fac_turned_cards_numbers.append (fac_cards_list[fac_result]["fac_c_number"])
                $ fac_turned_cards_values.append (fac_cards_list[fac_result]["fac_c_value"])
                $ fac_turns_left -= 1
                jump fac_turns_loop
        # предотвращаем открытие лишних карточек
        $ can_click = False
        if fac_turned_cards_values.count(fac_turned_cards_values[0]) != len(fac_turned_cards_values):
            $ renpy.pause (fac_wait, hard = True)
            python:
                for fac_i in range (0, len(fac_turned_cards_numbers) ):
                    fac_cards_list[fac_turned_cards_numbers[fac_i]]["fac_c_chosen"] = False
        else:
            $ renpy.pause (fac_wait, hard = True)
            python: 
                for fac_i in range (0, len(fac_turned_cards_numbers) ):
                    fac_cards_list[fac_turned_cards_numbers[fac_i]]["fac_c_value"] = 'none'
                for fac_j in fac_cards_list:
                    if fac_j["fac_c_chosen"] == False:
                        renpy.jump ("fac_memo_game_loop")
                renpy.jump ("fac_memo_game_win")
        jump fac_memo_game_loop

# проигрыш
label fac_memo_game_lose:
    hide screen fac_memo_scr
    $ renpy.pause (0.1, hard = True)
    $ fac_itswin = False
    return

# выигрыш
label fac_memo_game_win:
    hide screen fac_memo_scr
    $ renpy.pause (0.1, hard = True)
    $ fac_itswin = True
    return